program Project1;

{$APPTYPE CONSOLE}
uses
  SysUtils;
var f,k,j,i,n,l:integer;
  x,y:array[1..5000] of integer;
  s,max:double;
  mnog:array[1..5000] of double;
function Calc(i1,j1:integer):double;
var k1:integer;
  a:double;
begin
  a:=0;
  for k1:=i1 to j1-1 do
    a:=a+(x[k1+1]-x[k1])*(y[k1]+y[k1+1])/2;
  Calc:=a;
end;
begin
  max:=0;
  assign(input,'input.txt');
  reset(input);
  assign(output,'output.txt');
  Rewrite(Output);
  read(n,l);
  for i:=1 to n do read(x[i],y[i]);
  for i:=2 to n do mnog[i]:=Calc(1,i);
  for i:=1 to n-2 do
    for j:=i+2 to n do begin
      if sqrt(sqr(x[i]-x[j])+sqr(y[i]-y[j]))>L then continue;
      f:=0;
      for k:=i+1 to j-1 do begin
        if ((x[k]-x[i])*(y[j]-y[i])-(x[j]-x[i])*(y[k]-y[i]))>0 then begin
          f:=1;break;
        end;
      end;
      if f=1 then continue;
      s:=mnog[j]-mnog[i]-(x[j]-x[i])*(y[j]+y[i])/2;
      if s>max then max:=s;
   end;
  writeln(max);
  Close(Input);
  Close(Output);
end.
